import 'package:flutter/material.dart';

import 'app_setting.dart';
import 'form_and_layout_build.dart';
import 'layout_form_renderer.dart';

class DynamicPage extends StatefulWidget {
  final String pageId;

  DynamicPage({Key? key, required this.pageId}) : super(key: key);

  @override
  _DynamicPageState createState() => _DynamicPageState();
}

class _DynamicPageState extends State<DynamicPage> {
  late FormSource _source;

  @override
  void initState() {
    // _source =
    //     FormSource(url: "${AppSetting.serverUrlPrefix}/flutterJson/#pageId#");
    _source = FormSource(
        url:
            "${AppSetting.serverUrlPrefix}/entry/form/fetchEntryFormJson/#pageId#");
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        backgroundColor: Colors.grey[300],
        appBar: AppBar(
          title: Text("Entry Form", style: TextStyle(fontFamily: 'Lato')),
          actions: [
            IconButton(icon: Icon(Icons.upload_file), onPressed: () {})
          ],
        ),
        body: Padding(
            padding: EdgeInsets.all(20),
            child: SingleChildScrollView(
                child: Column(
              mainAxisAlignment: MainAxisAlignment.start,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [_getDynamicForm()],
            ))));
  }

  Widget _getDynamicForm() {
    return Container(
        width: double.infinity,
        //width: Util.getWidthPctOfScreen(context, 85),
        child: FormAndLayoutBuild(
            source: _source,
            genInitFormData: () {
              return Map<String, dynamic>();
            },
            pageId: widget.pageId));
  }
}
