import 'package:dynamic_widget/dynamic_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import '../util.dart';
import '../layout_form_renderer.dart';

class CardParser extends WidgetParser {
  @override
  String get widgetName => "Card";

  @override
  Widget parse(Map<String, dynamic> map, BuildContext buildContext,
      ClickListener? listener) {
    return Card(
        color: map.containsKey(LayoutForm.PROP_COLOR)
            ? HexColor.fromHex(map[LayoutForm.PROP_COLOR])
            : Colors.white,
        elevation: map.containsKey(LayoutForm.PROP_ELEVATION)
            ? map[LayoutForm.PROP_ELEVATION]
            : 5,
        shape: map.containsKey(LayoutForm.PROP_ROUNDED_RECTANGLE_BORDER_RADIUS)
            ? RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(
                    map[LayoutForm.PROP_ROUNDED_RECTANGLE_BORDER_RADIUS]))
            : RoundedRectangleBorder(borderRadius: BorderRadius.circular(32)),
        child: DynamicWidgetBuilder.buildFromMap(
            map[LayoutForm.PROP_CHILD], buildContext, listener));
  }

  @override
  Type get widgetType => Card;

  @override
  Map<String, dynamic>? export(Widget? widget, BuildContext? buildContext) {
    return Map<String, dynamic>();
  }
}
