import 'package:dynamic_widget/dynamic_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import '../layout_form_renderer.dart';

class FlexibleParser extends WidgetParser {
  @override
  String get widgetName => "Flexible";

  @override
  Widget parse(Map<String, dynamic> map, BuildContext buildContext,
      ClickListener? listener) {
    return Flexible(
        flex: map.containsKey(LayoutForm.PROP_FLEX)
            ? map[LayoutForm.PROP_FLEX]
            : 1,
        child: DynamicWidgetBuilder.buildFromMap(
            map[LayoutForm.PROP_CHILD], buildContext, listener)!);
  }

  @override
  Type get widgetType => Flexible;

  @override
  Map<String, dynamic>? export(Widget? widget, BuildContext? buildContext) {
    return Map<String, dynamic>();
  }
}
