import 'package:dynamic_widget/dynamic_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import '../formcomponent/partial_size_column.dart';
import '../layout_form_renderer.dart';

class PartialSizeColumnParser extends WidgetParser {
  @override
  String get widgetName => "PartialSizeColumn";

  @override
  Widget parse(Map<String, dynamic> map, BuildContext buildContext,
      ClickListener? listener) {
    String? id = map[LayoutForm.PROP_INPUT_ID];
    String? label = map[LayoutForm.PROP_INPUT_LABEL];
    bool? visible = map[LayoutForm.PROP_INPUT_VISIBLE];
    int? flex = map[LayoutForm.PROP_FLEX];
    bool? compulsory = map[LayoutForm.PROP_COMPULSORY];

    return PartialSizeColumn(
        id: id ?? "",
        label: label ?? "",
        visible: visible ?? true,
        flex: flex ?? 1,
        compulsory: compulsory ?? false,
        child: DynamicWidgetBuilder.buildFromMap(
            map[LayoutForm.PROP_CHILD], buildContext, listener)!);
  }

  @override
  Type get widgetType => PartialSizeColumn;

  @override
  Map<String, dynamic>? export(Widget? widget, BuildContext? buildContext) {
    return Map<String, dynamic>();
  }
}
